#!/usr/bin/env node



// process.exit();

/*
    Get all matching files in the cwd ".vow.js"
*/

const extension = ".vow.js";
const progress= "◴◷◶◵";

function Keeper({ base }) {
    this.base = base;
    this.ids = {};
    this.files = {};
    this._endOfInput = false;

    this.index = 1;

    this.ledger = [];
}
Keeper.prototype.endOfInput = function() {
    this._endOfInput = true;
    // require('venatici/prynt')('all inputs received');
}
Keeper.prototype.addFiles = function({ files }) {
    for (let i=0; i <= files.length - 1; i++) {
        this.files[ files[i] ] = null;
    }

    // require('venatici/prynt')(this.files)
}
Keeper.prototype.add = function({ key, caller_file, evaluated }) {
    const id = require('auriga/id/unique')(this.ids, "dojx");
    const relative_path = require('path').relative(
        this.base,
        caller_file
    );

    const index = this.index++ + 1;

    this.ids[ id ] = {
        key,
        relative_path,
        index,
        status: "started"
    };

    this.ledger.push({
        event: "add",
        id,
        key,
        relative_path
    });

    const proc = require('venatici/fork')({
        script: require('path').resolve(__dirname, "vow-test.js"),
        env: {
            NODE_PATH: require('path').resolve(__dirname, "plugins")
        }
    });

    proc.send(evaluated)
    proc.on('message', (status) => {
        keeper.update({
            event: status,
            id
        });
    });

    require('murex')({
        line: {
            [index]: `[  ] ${ key }`,
        }
    });

    return id;
}
Keeper.prototype.update = function({ id, event }) {
    const { key, relative_path, index } = this.ids[ id ];

    if (event === "yes") {
        this.ids[ id ].status = "yes";

        require('murex')({
            line: {
                [index]: `[✅ ] ${ key }`,
            }
        });
    }
    else if (event === "no") {
        this.ids[ id ].status = "no";

        require('murex')({
            line: {
                [index]: `[❌ ] ${ key }`,
            }
        });
    }

    this.tryDone();


    // require('venatici/prynt')({
    //     id,
    //     key,
    //     file: relative_path,
    //     event
    // });
}
Keeper.prototype.start = function() {

}
Keeper.prototype.tryDone = function() {

}

const keeper = new Keeper({
    base: process.cwd()
});


global.guarantee = function(vows) {
    const caller_file = require('venatici/trace')()[1].getFileName();

    require('auriga/object/read')({
        object: vows,
        each: function(key, value, next) {
            const vow = vows[key];
            const evaluated = vow.toString();

            const id = keeper.add({
                key,
                caller_file,
                evaluated
            });

            next();
        },
        done: function() {

        }
    });
}

const vows = [];

require('auriga/circuit')()
.task({
    id: 1,
    fn: function(task) {
        require('venatici/dir/get-all-entities')({
            dp: process.cwd(),
            outputKind: "files array",
            success: (results) => {
                keeper.addFiles({
                    files: results
                });

                for (let i=0; i <= results.length - 1; i++) {
                    const result = results[i];

                    if (result.endsWith(extension)) {
                        vows.push(result);
                    }
                }

                task.done();
            },
            failure: (error) => {

            }
        });
    }
})
.task({
    id: 2,
    after: 1,
    fn: function() {
        require("auriga/array/read")({
            array: vows,
            each: function(entry, index, next) {
                require(entry);
                next();
            },
            done: function() {
                keeper.endOfInput();
            }
        });
    }
});









////
